      SUBROUTINE AFP3D(A,N,M,W,S)
      DIMENSION A(N,M),W(M),S(N)
      INTEGER N,M,S,I,J,B,G,H
      DOUBLE PRECISION A,W,C,D,E,F,K,R,T,BD,BJ,DSIGN,DSQRT,
     1DABS
      DO 18 B=1,N
      IF(B.NE.M) GO TO 1
      W(B)=A(B,B)
      A(B,B)=0.D0
      GO TO 19
    1 H=B
      C=0.0D0
      DO 5 I=B,N
      F=0.D0
      DO 2 J=B,M
      T=DABS(A(I,J))
      IF(F.GE.T) GO TO 2
      F=T
    2 CONTINUE
      IF(F.EQ.0.D0) GO TO 4
      K=1.D0/F
      D=0.D0
      DO 3 J=B,M,1
      D=D+A(I,J)*K*A(I,J)*K
    3 CONTINUE
      F=DSQRT(D)*F
    4 IF(C.GE.F) GO TO 5
      C=F
      H=I
    5 CONTINUE
      IF(H.EQ.B) GO TO 7
      DO 6 J=1,M,1
      BD=A(H,J)
      A(H,J)=A(B,J)
      A(B,J)=BD
    6 CONTINUE
    7 S(B)=H
      DO 8 J=B,M,1
      W(J)=A(B,J)
    8 CONTINUE
      IF(C.EQ.0.D0) GO TO 18
      R=1.D0/C
      DO 9 J=B,M,1
      W(J)=W(J)*R
    9 CONTINUE
      IF(W(B).NE.0.D0) GO TO 10
      E=1.D0
      W(B)=1.D0
      GO TO 12
   10 E=DSIGN(1.D0,W(B))
      R=1.D0+DABS(W(B))
      W(B)=E*R
      R=1.D0/DSQRT(R)
      DO 11 J=B,M,1
      W(J)=W(J)*R
   11 CONTINUE
   12 E=-C*E
      DO 13 J=B,M,1
      A(B,J)=W(J)
   13 CONTINUE
      IF(B.EQ.N) GO TO 17
      G=B+1
      DO 16 I=G,N,1
      BJ=0.D0
      DO 14 J=B,M,1
      BJ=BJ+A(I,J)*W(J)
   14 CONTINUE
      DO 15 J=B,M,1
      A(I,J)=A(I,J)-BJ*W(J)
   15 CONTINUE
   16 CONTINUE
   17 W(B)=E
   18 CONTINUE
   19 RETURN
      END
